=== debian/changelog ===
ocproxy (1.50-1) unstable; urgency=low

  * Initial release. (Closes: #693792)

 -- Kevin Cernekee <cernekee@gmail.com>  Sun, 06 Jul 2014 12:39:40 -0700
