=== debian/control ===
Source: ocproxy
Section: net
Priority: optional
Maintainer: Kevin Cernekee <cernekee@gmail.com>
Build-Depends: debhelper (>= 9),
	       libevent-dev (>= 2.0.16),
	       dh-autoreconf
Standards-Version: 3.9.5
Homepage: https://github.com/cernekee/ocproxy
Vcs-Git: git://anonscm.debian.org/collab-maint/ocproxy.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ocproxy.git

Package: ocproxy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: openconnect
Suggests: dante-client
Description: SOCKS proxy for openconnect
 ocproxy is a SOCKS and port-forwarding proxy for use with openconnect.
 It implements its own userland IP stack, allowing a non-administrator to
 establish VPN connections without a need for tunnel devices. Instead
 of adding the host machine to the network at the other end of the VPN,
 ocproxy listens for local connections and forwards their traffic over the
 VPN, similar to "ssh -D" and "ssh -L".  Web browsers, remote login utilities
 and other programs can then access resources on the VPN through the
 proxy.  Applications that are unaware of the proxy cannot accidentally send
 traffic over the VPN, and multiple ocproxy instances may be connected to
 different VPNs concurrently.
