=== debian/rules ===
#!/usr/bin/make -f

# Disable AM_SILENT_RULES so buildd can check our flags
export V = 1

%:
	dh $@ --with autoreconf
