=== debian/watch ===
version=3

http://githubredir.debian.net/github/cernekee/ocproxy /v(.+).tar.gz
