=== debian/changelog ===
ocproxy (1.60-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Boyuan Yang ]
  * Rebuild against GCC 15.
  * debian/compat: Dropped in favor of debhelper-compat.
  * debian/watch: Update to version 5.

 -- Boyuan Yang <byang@debian.org>  Sun, 22 Feb 2026 20:58:48 -0500

ocproxy (1.60-1) unstable; urgency=medium

  * d/gbp.conf: Use new [buildpackage] format
  * d/watch: Replace deprecated githubredir URL
  * Bump Standards-Version to 3.9.8, no changes needed.
  * d/copyright: Update Format using "cme fix dpkg-copyright"
  * Bump debhelper compatibility level to 10
  * d/control: Use canonical https URLs for Vcs-* fields
  * d/control: Drop unnecessary dependencies on obsolete package versions
  * d/control: Run `wrap-and-sort`
  * New upstream version 1.60
  * d/rules: Enable all hardening flags
  * d/patches: Backport man page update from upstream

 -- Kevin Cernekee <cernekee@gmail.com>  Fri, 13 Jan 2017 08:03:57 -0800
