=== debian/control ===
--- 
+++ 
@@ -1,18 +1,15 @@
 Source: ocproxy
 Section: net
-Priority: optional
 Maintainer: Kevin Cernekee <cernekee@gmail.com>
-Build-Depends: debhelper (>= 9),
-	       libevent-dev (>= 2.0.16),
-	       dh-autoreconf
-Standards-Version: 3.9.5
+Build-Depends: debhelper-compat (= 13), libevent-dev
+Standards-Version: 4.7.3
 Homepage: https://github.com/cernekee/ocproxy
-Vcs-Git: git://anonscm.debian.org/collab-maint/ocproxy.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ocproxy.git
+Vcs-Git: https://salsa.debian.org/debian/ocproxy.git
+Vcs-Browser: https://salsa.debian.org/debian/ocproxy
 
 Package: ocproxy
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: openconnect
 Suggests: dante-client
 Description: SOCKS proxy for openconnect
